%PAKCS1.14 swi7 VARIABLESHARING

:-noSingletonWarnings.
:-noRedefineWarnings.
:-noDiscontiguousWarnings.

:-importModule('Maybe').
:-importModule('Prelude').
:-importModule('RedBlackTree').


:-curryModule('Set').

%%%%%%%%%%%% function types %%%%%%%%%%%%%%%%%%%
:-multifile functiontype/6.
:-dynamic functiontype/6.
functiontype('Set.empty',empty,0,'Set.empty',nofix,'TCons'('RedBlackTree.RedBlackTree',[_G961796])).
functiontype('Set.null',null,0,'Set.null',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G970702]),'TCons'('Prelude.Bool',[]))).
functiontype('Set.elem',elem,1,'Set.elem',nofix,'FuncType'(_G979566,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G979566]),'TCons'('Prelude.Bool',[])))).
functiontype('Set.insert',insert,0,'Set.insert',nofix,'FuncType'(_G988520,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G988520]),'TCons'('RedBlackTree.RedBlackTree',[_G988520])))).
functiontype('Set.delete',delete,0,'Set.delete',nofix,'FuncType'(_G997516,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G997516]),'TCons'('RedBlackTree.RedBlackTree',[_G997516])))).
functiontype('Set.toList',toList,0,'Set.toList',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G1006593]),'TCons'([],[_G1006593]))).
functiontype('Set.fromList',fromList,0,'Set.fromList',nofix,'FuncType'('TCons'([],[_G1015442]),'TCons'('RedBlackTree.RedBlackTree',[_G1015442]))).
functiontype('Set.union',union,1,'Set.union',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G1024432]),'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G1024432]),'TCons'('RedBlackTree.RedBlackTree',[_G1024432])))).
functiontype('Set.intersect',intersect,2,'Set.intersect',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G1033518]),'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G1033518]),'TCons'('RedBlackTree.RedBlackTree',[_G1033518])))).
functiontype('Set.disjoint',disjoint,2,'Set.disjoint',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G450527]),'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G450527]),'TCons'('Prelude.Bool',[])))).

%%%%%%%%%%%% constructor types %%%%%%%%%%%%%%%%%%%
:-multifile constructortype/7.
:-dynamic constructortype/7.

%%%%%%%%%%%% function definitions %%%%%%%%%%%%%%%%%%%
'Set.empty'(_G471540,_G471541,_G471542):-freeze(_G471541,'blocked_Set.empty'(_G471540,_G471541,_G471542)).
'blocked_Set.empty'(_G471698,_G471701,_G471704):-hnf('RedBlackTree.empty'(partcall(2,'Prelude.==',[]),partcall(2,'Prelude.==',[]),partcall(2,'Prelude.<',[])),_G471698,_G471701,_G471704).

'Set.null'(_G472364,_G472365,_G472366):-freeze(_G472365,'blocked_Set.null'(_G472364,_G472365,_G472366)).
'blocked_Set.null'(_G472402,_G472405,_G472408):-hnf(partcall(1,'RedBlackTree.isEmpty',[]),_G472402,_G472405,_G472408).

'Set.elem'(_G472758,_G472759,_G472760,_G472761):-freeze(_G472760,'blocked_Set.elem'(_G472758,_G472759,_G472760,_G472761)).
'blocked_Set.elem'(_G472796,_G472923,_G472926,_G472929):-hnf('Prelude..'(partcall(1,'Maybe.isJust',[]),partcall(1,'RedBlackTree.lookup',[_G472796])),_G472923,_G472926,_G472929).

'Set.insert'(_G473571,_G473572,_G473573):-freeze(_G473572,'blocked_Set.insert'(_G473571,_G473572,_G473573)).
'blocked_Set.insert'(_G473609,_G473612,_G473615):-hnf(partcall(2,'RedBlackTree.update',[]),_G473609,_G473612,_G473615).

'Set.delete'(_G474004,_G474005,_G474006):-freeze(_G474005,'blocked_Set.delete'(_G474004,_G474005,_G474006)).
'blocked_Set.delete'(_G474042,_G474045,_G474048):-hnf(partcall(2,'RedBlackTree.delete',[]),_G474042,_G474045,_G474048).

'Set.toList'(_G474437,_G474438,_G474439):-freeze(_G474438,'blocked_Set.toList'(_G474437,_G474438,_G474439)).
'blocked_Set.toList'(_G474475,_G474478,_G474481):-hnf(partcall(1,'RedBlackTree.tree2list',[]),_G474475,_G474478,_G474481).

'Set.fromList'(_G474915,_G474916,_G474917):-freeze(_G474916,'blocked_Set.fromList'(_G474915,_G474916,_G474917)).
'blocked_Set.fromList'(_G475033,_G475036,_G475039):-hnf(partcall(1,'Prelude.foldr',['Set.empty','Set.insert']),_G475033,_G475036,_G475039).

'Set.union'(_G475553,_G475554,_G475555,_G475556):-freeze(_G475555,'blocked_Set.union'(_G475553,_G475554,_G475555,_G475556)).
'blocked_Set.union'(_G475591,_G475758,_G475761,_G475764):-hnf('Prelude..'(partcall(1,'Prelude.foldr',[_G475591,'Set.insert']),'Set.toList'),_G475758,_G475761,_G475764).

'Set.intersect'(_G476517,_G476518,_G476519,_G476520,_G476521):-freeze(_G476520,'blocked_Set.intersect'(_G476517,_G476518,_G476519,_G476520,_G476521)).
'blocked_Set.intersect'(_G476560,_G476569,_G476929,_G476932,_G476935):-hnf('Prelude.$'('Set.fromList','Prelude.$'(partcall(1,'Prelude.filter',[partcall(1,'Prelude.flip',[_G476569,partcall(1,'Set.elem',[])])]),'Prelude.apply'('Set.toList',_G476560))),_G476929,_G476932,_G476935).

'Set.disjoint'(_G478115,_G478116,_G478117,_G478118,_G478119):-freeze(_G478118,'blocked_Set.disjoint'(_G478115,_G478116,_G478117,_G478118,_G478119)).
'blocked_Set.disjoint'(_G478158,_G478167,_G478327,_G478330,_G478333):-hnf('Prelude.apply'('Set.null','Set.intersect'(_G478158,_G478167)),_G478327,_G478330,_G478333).

:-costCenters(['']).




%%%%% Number of shared variables: 0
